
#include <stdio.h>
#include <windows.h>

unsigned char jfifHeader[10]=
{
	0xff,
	0xd8,
	0xff,
	0xe0,
	0x00,
	0x10,
	0x4a,
	0x46,
	0x49,
	0x46
};

int strricmp(const char *string1,const char *string2) // Recerse case in-sensitive string compare with a twist
{
	char *s1=((char *)string1)+strlen(string1)-1;
	char *s2=((char *)string2)+strlen(string2)-1;
	int c;
	while (s1>=string1 && s2>=string2)
	{
		c=(toupper(*s1)-toupper(*s2));
		if (c!=0)
			return c;
		s1--;
		s2--;
	}

	return 0;
}

const char *stristr(const char * str1,const char * str2,bool caseSensitive)
{
	char *cp = (char *) str1;
	char *s1, *s2;

	if ( !*str2 )
		return((char *)str1);

	if (caseSensitive==false)
	{
			while (*cp)
			{
					s1 = cp;
					s2 = (char *) str2;
			while ( *s1 && *s2 && !(toupper((int)*s1)-toupper((int)*s2)) )
       				s1++, s2++;
					if (!*s2)
							return(cp);
	
					cp++;
			}
	}
	else
	{
			while (*cp)
			{
					s1 = cp;
					s2 = (char *) str2;
			while ( *s1 && *s2 && !(*s1-*s2) )
        			s1++, s2++;
					if (!*s2)
							return(cp);
	
					cp++;
			}
	}

	return 0;
}

void fixFileIfNessary(const char *filename,DWORD size)
{
	const char *extension=stristr(filename,".jpg",true);
	if (!extension)
	{
		printf("Unable to find extension, skipping %s\n",filename);
		return;
	}
	unsigned char *buffer=new unsigned char[size];
	if (!buffer)
	{
		printf("Unable to allocate memory, skipping %s\n",filename);
		return;
	}
	FILE *in=fopen(filename,"rb");
	if (!in)
	{
		printf("Unable to open file, skipping %s\n",filename);
		delete buffer;
		return;
	}
	if (fread(buffer,size,1,in)==1)
	{
		fclose(in);
		char newFile[MAX_PATH];
		strncpy(newFile,filename,extension-filename);
		newFile[extension-filename]='\0';
		strcat(newFile,"_fixed");
		strcat(newFile,extension);
		FILE *out=fopen(newFile,"wb");
		if (out)
		{
			size_t newSize=size;
			unsigned char *runner=buffer;
			bool bingo=false;
			while (newSize>=0)
			{
				if (memcmp(runner,jfifHeader,sizeof(jfifHeader))==0)
				{
					if (runner!=buffer)
					{
						fwrite(runner,newSize,1,out);
						fclose(out);
						bingo=true;
					}
					break;
				}
				runner++;
				newSize--;
			}
			
			if (bingo==false)
			{
				fclose(out);
				DeleteFile(newFile);
			}
			else
			{
				printf(".");
				char oldFile[MAX_PATH];
				strcpy(oldFile,filename);
				strcat(oldFile,"_old.jpg");
				if (MoveFile(filename,oldFile)==FALSE)
					printf("%s => %s failed.\n",filename,oldFile);
				if (MoveFile(newFile,filename)==FALSE)
					printf("%s => %s failed.\n",newFile,filename);
			}
		}
		else
		{
			printf("Unable to create file %s, skipping: %s\n",newFile,filename);
		}

	}
	else
		fclose(in);
	delete buffer;
}

void traverse()
{
	WIN32_FIND_DATA fd;
	HANDLE h=FindFirstFile("*.*",&fd);
	if (h==INVALID_HANDLE_VALUE)
		return;
	do
	{
		if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==FILE_ATTRIBUTE_DIRECTORY)
		{
			if (fd.cFileName[0]=='.')
				continue;
			SetCurrentDirectory(fd.cFileName);
			traverse();
			SetCurrentDirectory("..");
		}
		else
		{
			if (strricmp(fd.cFileName,".jpg")==0)
				fixFileIfNessary(fd.cFileName,fd.nFileSizeLow);
		}
	} while (FindNextFile(h,&fd));
	FindClose(h);
}

int main(int,char **)
{
	printf("ABRFIX (www.abrianna.com) fixer v0.01 by pwd\n"
		   "Fixes bad beginning of JPEG header on www.brianna.com version 2.\n\n");
	traverse();
	return 0;
}